<!DOCTYPE html>
<html>

<head>
  <title> Task 25.30 ... Tạo đơn hàng - xem chi tiết </title>
  <meta charset='utf-8'>
  <meta name='viewport' content='width=device-width, initial-scale=1'>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onPageLoading()">
  <div class="container jumbotron">
    <div class="col-12">
      <div class="text-center mb-5">
        <h1> Create Order </h1>
      </div>
      <div class="form-group row">
        <label for="" class="col-sm-2 col-form-label">Cỡ Combo</label>
        <div class="col-sm-4">
          <select id="select-size" class="form-control">
            <option value="NOT_SELECT_COMBO"> Chọn cỡ Combo (Combo size)</option>
            <option value="S"> Nhỏ</option>
            <option value="M"> Vừa</option>
            <option value="L"> Lớn</option>
          </select>
        </div>
        <label for="" class="col-sm-2 col-form-label">Đồ uống</label>
        <div class="col-sm-4">
          <select class="form-control" id="select-drink">
            <option value="NOT_SELECT_DRINK">Chọn đồ uống</option>
          </select>
        </div>
      </div>
      <div class="form-group row">
        <label class="col-sm-2 col-form-label">Mã voucher</label>
        <div class="col-sm-4">
          <input id="input-voucher" type="text" class="form-control" placeholder="Voucher ID (mã voucher)">
        </div>
        <label class="col-sm-2 col-form-label">Loại pizza</label>
        <div class="col-sm-4">
          <select id="select-pizza" class="form-control"> <!-- select chưa có id, các option chưa có value-->
            <option value="NOT_SELECT_PIZZA"> Chọn loại pizza </option>
            <option value="Seafood"> Hải sản</option>
            <option value="Hawaii"> Ha wai </option>
            <option value="Bacon"> Thịt hun khói </option>
          </select>
        </div>
      </div>
      <div class="form-group row">
        <label class="col-sm-2 col-form-label" for="">Họ và tên</label>
        <div class="col-sm-4">
          <input id="input-fullname" type="text" class="form-control" placeholder="Họ và tên">
        </div>
        <label for="" class="col-sm-2 col-form-label">Email</label>
        <div class="col-sm-4">
          <input id="input-email" type="email" class="form-control" placeholder="Email">
        </div>
      </div>
      <div class="form-group row">
        <label class="col-sm-2 col-form-label">Số điện thoại</label>
        <div class="col-sm-4">
          <input id="input-mobile" type="text" class="form-control" placeholder="Số điện thoại">
        </div>
        <label class="col-sm-2 col-form-label">Địa chỉ</label>
        <div class="col-sm-4">
          <input id="input-adress" type="text" class="form-control" placeholder="Địa chỉ">
        </div>
      </div>
      <div class="form-group">
        <label>Lời nhắn</label>
        <textarea id="input-message" class="form-control h-75" placeholder="Lời nhắn"></textarea>
      </div>
      <div class="form-group">
        <button onclick="onBtnCreateOrderClick()" class="btn btn-primary">Create Order</button>
        <button onclick="onBtnShowDataCreate()" id="btn-order-data" class="btn btn-secondary">Show Order Data in New Form</button>
      </div>
    </div>
  </div>
  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gREQUEST_CREATE_SUCCESS = 201; // status 201 - tạo thành công
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */


    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
      // load dữ liệu vào select car
      loadDataDrinkList();
    }
    //
    function onBtnCreateOrderClick() {
      console.log("Nút tạo đơn hàng được ấn ");
      var vObjCreate =
      {
        kichCo: "",
        duongKinh: "",
        suon: "",
        salad: "",
        loaiPizza: "",
        idVourcher: "",
        idLoaiNuocUong: "",
        soLuongNuoc: "",
        hoTen: "",
        thanhTien: "",
        email: "",
        soDienThoai: "",
        diaChi: "",
        loiNhan: "",
      };
      readDataCreateOrder(vObjCreate);
      var vDuLieuHopLe = valieDateOrderCreate(vObjCreate);
      if (vDuLieuHopLe) {
        var vXmlHttpCreateOrder = new XMLHttpRequest();
        callAPICreateOrder(vXmlHttpCreateOrder, vObjCreate);
        vXmlHttpCreateOrder.onreadystatechange = function () {
          if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_CREATE_SUCCESS) { // status 201 tao thanh cong
            showDataCreateOrder(vXmlHttpCreateOrder);
            console.log(vXmlHttpCreateOrder);
          }
        }
      }
    }
    //
    function onBtnShowDataCreate()
    {
      var vElementButtonOrder = document.getElementById("btn-order-data");
      var vGetOrderCode = vElementButtonOrder.dataset.ordercode ;
      console.log("Order Code là : " + vGetOrderCode);
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Hàm thực hiện call api để load dữ liệu vào drink list
    function loadDataDrinkList() {
      var vXhttp = new XMLHttpRequest();
      vXhttp.open("GET", "http://203.171.20.210:8080/devcamp-pizza365/drinks", true);
      vXhttp.send();
      vXhttp.onreadystatechange = function () {
        if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
          console.log(vXhttp.responseText); // ghi response text ra console.log
          handleLoadDataToSelectDrink(vXhttp);
        }
      };
    }

    // handle data load to select drink
    function handleLoadDataToSelectDrink(paramXhttp) {
      var vArrayDrinkList = JSON.parse(paramXhttp.responseText);
      console.log("array drink list = " + vArrayDrinkList.length);
      //load data to drink select
      var vElementSelectDrink = document.getElementById("select-drink");
      for (var bIterator = 0; bIterator < vArrayDrinkList.length; bIterator++) {
        var vDrinkOptionElement = document.createElement("option");
        vDrinkOptionElement.value = vArrayDrinkList[bIterator].maNuocUong;
        vDrinkOptionElement.text = vArrayDrinkList[bIterator].tenNuocUong;
        vElementSelectDrink.appendChild(vDrinkOptionElement);
      }
    }
    // vùng sự kiện tạo đơn hàng 
    function readDataCreateOrder(paramObj) {
      var vElementPizzaSize = document.getElementById("select-size");
      var vElementSelectDrink = document.getElementById("select-drink");
      var vElementVoucher = document.getElementById("input-voucher");
      var vElementSelectPizza = document.getElementById("select-pizza");
      var vElementFullName = document.getElementById("input-fullname");
      var vElementEmail = document.getElementById("input-email");
      var vElementMobile = document.getElementById("input-mobile");
      var vElementAddress = document.getElementById("input-adress");
      var vElementMessage = document.getElementById("input-message");

      paramObj.kichCo = vElementPizzaSize.value;
      paramObj.idLoaiNuocUong = vElementSelectDrink.value;
      paramObj.soLuongNuoc = vElementSelectDrink.value;
      paramObj.idVourcher = vElementVoucher.value.trim();

      paramObj.loaiPizza = vElementSelectPizza.value.trim();
      paramObj.hoTen = vElementFullName.value.trim();
      paramObj.email = vElementEmail.value.trim();
      paramObj.soDienThoai = vElementMobile.value.trim();
      paramObj.diaChi = vElementAddress.value.trim();
      paramObj.loiNhan = vElementMessage.value.trim();

      if (paramObj.kichCo == "S") {
        paramObj.duongKinh = 20;
        paramObj.suon = 2;
        paramObj.salad = 200;
        paramObj.soLuongNuoc = 2;
        paramObj.thanhTien = 150000;
      }
      else if (paramObj.kichCo == "M") {
        paramObj.duongKinh = 24;
        paramObj.suon = 3;
        paramObj.salad = 300;
        paramObj.soLuongNuoc = 3;
        paramObj.thanhTien = 200000;
      }
      else if (paramObj.kichCo == "L") {
        paramObj.duongKinh = 30;
        paramObj.suon = 8;
        paramObj.salad = 500;
        paramObj.soLuongNuoc = 4;
        paramObj.thanhTien = 250000;
      }
    }
    //
    function valieDateOrderCreate(paramObj) {
      if (paramObj.kichCo == "NOT_SELECT_COMBO") {
        alert("Bạn cần chọn Combo");
        return false;
      }
      if (paramObj.idLoaiNuocUong == "NOT_SELECT_DRINK") {
        alert("Bạn cần chọn loại nước uống ");
        return false;
      }
      if (paramObj.idVourcher == "") {
        alert("Bạn chưa nhập mã giảm giá ");
        return false;
      }
      if (paramObj.loaiPizza == "NOT_SELECT_PIZZA") {
        alert("Bạn cần chọn loại Pizza ");
        return false;
      }
      if (paramObj.hoTen == "") {
        alert("Bạn chưa nhập thông tin đơn hàng ");
        return false;
      }
      if (paramObj.email == "") {
        alert("Bạn chưa nhập thông tin đơn hàng ");
        return false;
      }
      if (paramObj.soDienThoai == "") {
        alert("Bạn chưa nhập thông tin đơn hàng ");
        return false;
      }
      if (paramObj.diaChi == "") {
        alert("Bạn chưa nhập thông tin đơn hàng ");
        return false;
      }
      if (paramObj.loiNhan == "") {
        alert("Bạn chưa nhập thông tin đơn hàng ");
        return false;
      }
      return true;
    }
    // gọi API khởi tạo đơn hàng 
    function callAPICreateOrder(paramXhttp, paramObj) {
      paramXhttp.open("POST", gBASE_URL, true);
      paramXhttp.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
      paramXhttp.send(JSON.stringify(paramObj));
      console.log(paramObj);
    }
    //
    function showDataCreateOrder(paramXhttp) {
      //
      var vCreatOrder = paramXhttp.responseText ;
      console.log(vCreatOrder);
      var vPerson = JSON.parse(paramXhttp.responseText);
      console.log(vPerson);
      //
      var vOrderCode = vPerson.orderCode;
      //
      var vButtonOrder = document.getElementById("btn-order-data");
      vButtonOrder.setAttribute("data-ordercode", vOrderCode);

    }
  </script>


</body>

</html>